<script lang="ts">
  import { beforeNavigate } from '$app/navigation';
  import { data, successMessage, errorMessage } from '$lib/stores';
  import Sidebar from '$lib/Sidebar.svelte';
  import SuccessMessage from '$lib/SuccessMessage.svelte';
  import ErrorMessage from '$lib/ErrorMessage.svelte';
  import { JSONEditor, Mode } from 'svelte-jsoneditor';
  import type { Content } from 'svelte-jsoneditor';

  let content: Content = {
    json: $data, // Note: an alternative is to set as text using the `text` attribute
  };

  let mode = Mode.tree;

  // Reset success and error messages on page load
  successMessage.set('');
  errorMessage.set('');

  // Warn the user before leaving the page in case of unsaved changes
  let isDirty = false;

  function beforeUnload(e: Event) {
    if (isDirty) {
      e.preventDefault();
      // @ts-ignore:next-line This is recommended for legacy reasons, see https://developer.mozilla.org/en-US/docs/Web/API/Window/beforeunload_event
      e.returnValue = true;
    }
  }

  beforeNavigate(({ cancel }) => {
    if (
      isDirty &&
      !confirm(
        'Weet je zeker dat je de pagina wilt verlaten? Onopgeslagen veranderingen kunnen verloren gaan.',
      )
    ) {
      cancel();
    }
  });
</script>

<svelte:window on:beforeunload={beforeUnload} />

<svelte:head>
  <title>Data — FSC Policy Builder</title>
</svelte:head>

<div class="grid min-h-screen grid-cols-12">
  <Sidebar active="data" />

  <div class="col-span-7 bg-slate-50 p-6 sm:col-span-8 lg:col-span-9">
    <h1 class="mb-5 text-2xl font-medium">Data</h1>

    {#if $errorMessage}
      <ErrorMessage bind:message={$errorMessage} />
    {:else if $successMessage}
      <SuccessMessage bind:message={$successMessage} />
    {/if}

    <div class="mb-7">
      <span class="mr-2">Weergave:</span>
      <div class="inline-flex rounded-md shadow-sm" role="group">
        <button
          type="button"
          class="rounded-l-lg border border-slate-300 bg-white px-2.5 py-1.5 font-medium text-slate-600 hover:border-indigo-300 hover:bg-indigo-50 hover:text-indigo-800 focus:z-10 focus:ring-2 focus:ring-indigo-200 [&.active]:z-10 [&.active]:border-indigo-400 [&.active]:bg-indigo-100 [&.active]:text-indigo-900 [&.active]:shadow-inner [&.active]:shadow-indigo-800/10"
          class:active={mode === 'tree'}
          on:click={() => {
            mode = Mode.tree;
          }}
        >
          Visueel
        </button>
        <button
          type="button"
          id="mode-text"
          class="-ml-px rounded-r-lg border border-slate-300 bg-white px-2.5 py-1.5 font-medium text-slate-600 hover:border-indigo-300 hover:bg-indigo-50 hover:text-indigo-800 focus:z-10 focus:ring-2 focus:ring-indigo-200 [&.active]:z-10 [&.active]:border-indigo-400 [&.active]:bg-indigo-100 [&.active]:text-indigo-900 [&.active]:shadow-inner [&.active]:shadow-indigo-800/10"
          class:active={mode !== 'tree'}
          on:click={() => {
            mode = Mode.text;
          }}
        >
          JSON
        </button>
      </div>
    </div>

    <div id="jsoneditor" class="mb-7">
      <JSONEditor
        bind:content
        {mode}
        onRenderMenu={(items) => items.filter((_, index) => index > 3)}
        onChange={() => {
          isDirty = true;
        }}
      />
    </div>

    <p class="mb-7">
      <button
        on:click={() => {
          // @ts-ignore:next-line either .json or .text is set
          data.set(content.json || JSON.parse(content.text));
          isDirty = false;
          successMessage.set('Wijzigingen opgeslagen.');
        }}
        type="button"
        class="inline-block rounded-lg border border-indigo-600 bg-indigo-500 px-4 py-2.5 text-sm font-medium text-white shadow-sm hover:border-indigo-700 hover:bg-indigo-600 focus:outline-none focus:ring-4 focus:ring-indigo-200"
      >
        Wijzigingen opslaan
      </button>
    </p>
  </div>
</div>

<style lang="postcss">
  /* JSON editor customization */
  #jsoneditor {
    --jse-theme-color: #6366f1; /* Tailwind indigo-500 */
    --jse-theme-color-highlight: #4f46e5; /* Tailwind indigo-600 */
    --jse-key-color: #1f2937; /* Tailwind gray-800 */
    --jse-delimiter-color: #9ca3af; /* Tailwind gray-400 */

    :global(.jse-menu) {
      @apply rounded-t-md;
    }

    :global(.jse-contents) {
      @apply rounded-b-md border-slate-200;
    }
  }
</style>
